%Fourier Transforms
%Visualizing the Discrete Fourier Transform
%Construct a matrix f that is similar to the function f(m,n) in the example in Definition of Fourier Transform. Remember that f(m,n) is equal to 1 within the rectangular region and 0 elsewhere. Use a binary image to represent f(m,n).

close all
clear

f = zeros(30,30)
f(5:24,13:17) = 1;
imshow(f,'InitialMagnification','fit')

%%
%Compute and visualize the 30-by-30 DFT of f with these commands.

F = fft2(f);
F2 = log(abs(F));
imshow(F2,[-1 5],'InitialMagnification','fit') 
colormap(jet) 
colorbar

%%
%To obtain a finer sampling of the Fourier transform, add zero padding to f when computing its DFT. The zero padding and DFT computation can be performed in a single step with this command.

F = fft2(f,256,256);
%This command zero-pads f to be 256-by-256 before computing the DFT.

imshow(log(abs(F)),[-1 5])
colormap(jet) 
colorbar

%%
%The zero-frequency coefficient, however, is still displayed in the upper left corner rather than the center. You can fix this problem by using the function fftshift, which swaps the quadrants of F so that the zero-frequency coefficient is in the center.

F = fft2(f,256,256);F2 = fftshift(F);
imshow(log(abs(F2)),[-1 5]) 
colormap(jet) 
colorbar
%The resulting plot is identical to the one shown in Visualizing the Fourier Transform.












